from netgen.meshing import *
from netgen.meshing import Mesh as NetMesh
from ngsolve import *
from ngsolve import *

def AddEdgeEls (p1, dx, facenr, n, pids,mesh):
    for i in range(n):
        base = p1 + i*dx
        pnum = [base, base+dx]
        elpids = [pids[p] for p in pnum]
        mesh.Add (Element1D(elpids,index=i+1))
        if i < n/2:
            mesh.SetMaterial(i+1, 'mat1')
        else :
            mesh.SetMaterial(i+1, 'mat2')

def SegMesh(n,x0,x1,per):
    mesh = NetMesh(dim=1)
    pids = []
    for i in range(n+1):
        pids.append (mesh.Add (MeshPoint(Pnt(x0+(x1-x0)*i/n, 0, 0))))
    AddEdgeEls(0,1,1,n,pids,mesh)
    mesh.Add (Element0D( pids[0], index=1))
    mesh.Add (Element0D( pids[n], index=2))
    mesh.Add (Element0D( pids[int(n/2)], index=3))
    mesh.SetBCName(0, "left")
    mesh.SetBCName(1, "right")
    mesh.SetBCName(2, "interface")
    if per == 1:
        mesh.AddPointIdentification(pids[0],pids[n],1,2)
    return Mesh(mesh)

mesh = SegMesh(4, 0,1,False)
V = L2(mesh, order=0, dgjumps=True)
u,v = V.TnT()
a = BilinearForm(V)
n = specialcf.normal(mesh.dim)
uhat = IfPos(n, u, u.Other(bnd = 1))
# element-boundary formulation
a +=  -uhat*v*n*dx(element_boundary=True, definedon=mesh.Materials("mat1")) 

# skeleton-formulation
#a +=  -uhat*(v-v.Other())*n*dx(skeleton=True, definedon=mesh.Materials("mat1")) 
#a +=  -uhat*v*n*ds(skeleton=True, definedon=mesh.Boundaries("left")) 
### this line is bugged, ds do not know who is v!!!
#a +=  -uhat*v*n*ds(skeleton=True, definedon=mesh.Boundaries("interface")) 

a.Assemble()
gfu = GridFunction(V)
w = gfu.vec.CreateVector()

tau = 1/4
time = 0
tend = 1
while time < tend:
    a.Apply (gfu.vec, w)
    print("a(u)=", w)
    V.SolveM(w)
    gfu.vec.data += tau*w
    print("u=", gfu.vec)
    time += tau
